Algorithm Class Reference

Interface for all crypto algorithms. More...

Inheritance diagram for Algorithm:

## Public Member Functions

| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

Interface for all crypto algorithms.

Definition at line 495 of file cryptlib.h.

## Constructor & Destructor Documentation

## Algorithm()

Algorithm::Algorithm | ( | bool | checkSelfTestStatus = `true` | ) |

Interface for all crypto algorithms.

Parameters

  checkSelfTestStatus | determines whether the object can proceed if the self tests have not been run or failed.

When FIPS 140-2 compliance is enabled and checkSelfTestStatus == true, this constructor throws SelfTestFailure if the self test hasn't been run or fails.

FIPS 140-2 compliance is disabled by default. It is only used by certain versions of the library when the library is built as a DLL on Windows. Also see CRYPTOPP_ENABLE_COMPLIANCE_WITH_FIPS_140_2 in config.h.

Definition at line 89 of file cryptlib.cpp.

## Member Function Documentation

## AlgorithmName()

virtual std::string Algorithm::AlgorithmName | ( |  | ) | const

inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet

Reimplemented in AuthenticatedSymmetricCipher, SignatureVerificationFilter, SignerFilter, AuthenticatedDecryptionFilter, HashVerificationFilter, HashFilter, StreamTransformationFilter, ClassNullRNG, BitBucket, BLAKE2_Base< W, T_64bit >, BLAKE2_Base< word32, false >, BLAKE2_Base< word64, true >, DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >, RDSEED, HMAC< T >, CRC32C, Keccak, RDRAND, SHA3, CRC32, GCM_Base, CCM_Base, Adler32, VMAC_Base, and EAX_Base.

Definition at line 518 of file cryptlib.h.

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp